# -*-coding:utf-8-*-
import json

def cal_mention_f1(c, p, r):
    if r == 0 or p == 0:
        return 0, 0, 0
    print(c, p, r)
    r = c / r if r else 0
    p = c / p if p else 0

    if r and p:
        return 2 * p * r / (p + r), p, r
    return 0, p, r
if __name__ == '__main__':
    cadec_predict_path = "data/cadec_test_output.json"

    ### mention level analysis
    predict_path = cadec_predict_path

    with open(predict_path, "r", encoding="utf-8") as f:
        data = json.load(f)
    total_ent_c = 0  # tp
    total_ent_p = 0  # predict
    total_ent_t = 0  # true

    id2label = {"0": "pad", "1": "nnw", "2": "adr"}
    for d in data:
        sentence = d["sentence"]
        true_set = eval(d["true_entity"])
        predict_list = d["entity"]
        true_list = []
        for dd in true_set:
            index_str, label_id = dd.split("-#-")
            index = [eval(x) for x in index_str.split("-")]
            text = [sentence[x] for x in index]
            true_list.append({
                "text": text,
                "index": index,
                "type": id2label[label_id]
            })

        predict_set = set([str(x) for x in predict_list])
        true_set = set([str(x) for x in true_list])

        total_ent_t += len(true_set)
        total_ent_p += len(predict_set)
        total_ent_c += len(predict_set.intersection(true_set))

    e_f1, e_p, e_r = cal_mention_f1(total_ent_c, total_ent_p, total_ent_t)
    print(e_f1, e_p, e_r)